BeamAndGo.Member.Admin.Web/Pages/Admin/List.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using BeamAndGo.Core.Common;
using BeamAndGo.Core.Data;
using BeamAndGo.Member.Admin;
using BeamAndGo.Member.Admin.Web.Filters;
using BeamAndGo.Member.Admin.Web.Models;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;

namespace BeamAndGo.Member.Admin.Web.Pages.Admin
{
    [LoginRequired]
    [ValidateAntiForgeryToken]
    public class AdminListModel : PageModel
    {
        private readonly ApplicationOptions _applicationOptions;
        private readonly ILogger<AdminListModel> _logger;
        private readonly IMemberAdminService _MemberAdminService;


        public IEnumerable<MemberAdmin> MemberAdmins { get; private set; }
        public string MinExpiryDate { get; set; }


        [BindProperty]
        public DateTimeOffset? ExpiryDate { get; set; }
        [BindProperty(SupportsGet = true)]
        public int CurrentPage { get; set; } = 1;
        [BindProperty(SupportsGet = true)]
        public int PagesCount { get; set; } = 1;
        [BindProperty]
        public MemberAdminAccessLevel AccessLevel { get; set; }
        [BindProperty]
        public string AdminMemberSid { get; set; }
        [BindProperty(SupportsGet = true)]
        public string CurrentSearch { get; set; } = string.Empty;
        [BindProperty]
        public RecordStatus AdminRecordStatus { get; set; }


        public AdminListModel(ILogger<AdminListModel> logger,
                              IMemberAdminService MemberAdminService,
                              IOptions<ApplicationOptions> applicationOptions)
        {
            _logger = logger;
            _MemberAdminService = MemberAdminService;
            _applicationOptions = applicationOptions.Value;
        }

        public async Task<IActionResult> OnGetAsync(string search = "", int start = 0)
        {
            try
            {
                var sid = HttpContext.Session.GetString(SessionKey.MemberSid);
                var admin = await _MemberAdminService.GetByMemberSid(sid);

                if (admin.AccessLevel == MemberAdminAccessLevel.SuperAdmin)
                {
                    int count = 0;
                    start = start > 1 ? start : 1;
                    var startPage = start > 0 ? ((start - 1) * _applicationOptions.PageSize) : 0;
                    MinExpiryDate = DateTime.Now.ToString("yyyy-MM-dd");

                    if (!string.IsNullOrEmpty(search))
                    {
                        var iAsyncMemberAdmin = _MemberAdminService.Search(search, startPage);
                        MemberAdmins = iAsyncMemberAdmin.ToEnumerable();
                        count = MemberAdmins.Count();
                    }
                    else
                    {
                        MemberAdmins = await _MemberAdminService.ListAll(startPage);
                        count = await _MemberAdminService.Count();
                    }

                    CurrentPage = start;
                    CurrentSearch = search;
                    PagesCount = ((count - 1) / _applicationOptions.PageSize) + 1;
                }
                else
                {
                    string currentPageForError = Request.Path.ToString().Replace("/", " ");
                    return RedirectToPage("/Error", new { error = ErrorMessage.AccessDenied.Error, error_description = ErrorMessage.AccessDenied.ErrorDescription, error_page = currentPageForError });
                }
            }
            catch (Exception ex)
            {
                if (ex is ArgumentException || ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    return RedirectToPage("/Error", new { error = ExceptionExtensions.GetCode(ex), error_description = ExceptionExtensions.GetDescription(ex) });
                }
                else
                {
                    throw;
                }
            }

            return Page();
        }

        public async Task<IActionResult> OnPostRemoveAdmin()
        {
            try
            {
                await _MemberAdminService.Delete(AdminMemberSid);
                HttpContext.Session.SetString(SessionKey.NotificationMessage.Sucess, "Successfully removed admin");
            }
            catch (ArgumentException ex)
            {
                _logger.LogInformation(ex, ex.Message);
                HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)}");
            }
            catch (Exception ex)
            {
                if (ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                }
                else
                {
                    _logger.LogError(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, ErrorMessage.ErrorMessageDefault.ErrorDescription);
                }
            }

            return Redirect("~/Admin/List");
        }

        public async Task<IActionResult> OnPostUpdateAdmin()
        {
            try
            {
                var MemberAdmin = await _MemberAdminService.Update(AdminMemberSid, AccessLevel, ExpiryDate);

                if (AdminRecordStatus != MemberAdmin.RecordStatus)
                {
                    if (AdminRecordStatus == RecordStatus.Active)
                    {
                        var memberEnable = await _MemberAdminService.Enable(AdminMemberSid);
                    }
                    else
                    {
                        var memberDisable = await _MemberAdminService.Disable(AdminMemberSid);
                    }
                }

                HttpContext.Session.SetString(SessionKey.NotificationMessage.Sucess, "Successfully updated admin");
            }
            catch (ArgumentException ex)
            {
                _logger.LogInformation(ex, ex.Message);
                HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)}");
            }
            catch (Exception ex)
            {
                if (ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                }
                else
                {
                    _logger.LogError(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, ErrorMessage.ErrorMessageDefault.ErrorDescription);
                }
            }

            return Redirect("~/Admin/List");
        }
    }
}

BeamAndGo.Member.Admin.Web/Pages/RelationshipType/List.cshtml.cs
using System;
using System.Collections.Generic;
using System.Threading.Tasks;
using BeamAndGo.Core.Common;
using BeamAndGo.Core.Data;
using BeamAndGo.Member;
using BeamAndGo.Member.Admin;
using BeamAndGo.Member.Admin.Web.Filters;
using BeamAndGo.Member.Admin.Web.Models;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Logging;

namespace BeamAndGo.Member.Admin.Web.Pages.RelationshipType
{
    [ValidateAntiForgeryToken]
    [LoginRequired]
    public class RelationshipTypeListModel : PageModel
    {
        private readonly ILogger<RelationshipTypeListModel> _logger;
        private readonly IMemberAdminService _MemberAdminService;
        private readonly IMemberRelationshipTypeService _memberRelationshipTypeService;

        [BindProperty]
        public char? RelationshipTypeGender { get; set; }

        [BindProperty]
        public int RelationshipTypeId { get; set; }

        [BindProperty]
        public string RelationshipTypeName { get; set; }

        [BindProperty]
        public RecordStatus RelationshipTypeStatus { get; set; }
        [BindProperty]
        public RecordStatus CurrentRelationshipTypeStatus { get; set; }



        public IEnumerable<MemberRelationshipType> MemberRelationshipTypes { get; private set; }

        public RelationshipTypeListModel(ILogger<RelationshipTypeListModel> logger, IMemberAdminService MemberAdminService, IMemberRelationshipTypeService memberRelationshipTypeService)
        {
            _logger = logger;
            _MemberAdminService = MemberAdminService;
            _memberRelationshipTypeService = memberRelationshipTypeService;
        }

        public async Task<IActionResult> OnGetAsync()
        {
            try
            {
                var sid = HttpContext.Session.GetString(SessionKey.MemberSid);
                var admin = await _MemberAdminService.GetByMemberSid(sid);

                if (admin.AccessLevel == MemberAdminAccessLevel.SuperAdmin)
                {
                    MemberRelationshipTypes = await _memberRelationshipTypeService.ListAll();
                }
                else
                {
                    string currentPageForError = Request.Path.ToString().Replace("/", " ");
                    return RedirectToPage("/Error", new { error = ErrorMessage.AccessDenied.Error, error_description = ErrorMessage.AccessDenied.ErrorDescription, error_page = currentPageForError });
                }

            }
            catch (Exception ex)
            {
                if (ex is ArgumentException || ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    return RedirectToPage("/Error", new { error = ExceptionExtensions.GetCode(ex), error_description = ExceptionExtensions.GetDescription(ex) });
                }
                else
                {
                    throw;
                }
            }

            return Page();
        }

        public async Task<IActionResult> OnPostCreateRelationshipType()
        {
            try
            {
                var adminMemberSid = HttpContext.Session.GetString(SessionKey.MemberSid);

                var MemberAdmin = await _memberRelationshipTypeService.Create(RelationshipTypeName, RelationshipTypeGender);

                HttpContext.Session.SetString(SessionKey.NotificationMessage.Sucess, "Successfully created relationship type");
            }
            catch (ArgumentException ex)
            {
                _logger.LogInformation(ex, ex.Message);
                HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)}");
            }
            catch (Exception ex)
            {
                if (ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                }
                else
                {
                    _logger.LogError(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, ErrorMessage.ErrorMessageDefault.ErrorDescription);
                }
            }

            return Redirect("~/RelationshipType/List");
        }

        public async Task<IActionResult> OnPostRemoveRelationshipType()
        {
            try
            {
                var adminMemberSid = HttpContext.Session.GetString(SessionKey.MemberSid);

                await _memberRelationshipTypeService.Delete(RelationshipTypeId);
                HttpContext.Session.SetString(SessionKey.NotificationMessage.Sucess, "Successfully removed relationship type");
            }
            catch (ArgumentException ex)
            {
                _logger.LogInformation(ex, ex.Message);
                HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)}");
            }
            catch (Exception ex)
            {
                if (ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                }
                else
                {
                    _logger.LogError(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, ErrorMessage.ErrorMessageDefault.ErrorDescription);
                }
            }

            return Redirect("~/RelationshipType/List");
        }

        public async Task<IActionResult> OnPostUpdateRelationshipType()
        {
            try
            {
                var adminMemberSid = HttpContext.Session.GetString(SessionKey.MemberSid);

                var MemberAdmin = await _memberRelationshipTypeService.Update(RelationshipTypeId, RelationshipTypeName, RelationshipTypeGender);


                if (CurrentRelationshipTypeStatus != RelationshipTypeStatus)
                {
                    if (RelationshipTypeStatus == RecordStatus.Active)
                    {
                        await _memberRelationshipTypeService.Enable(RelationshipTypeId);
                    }
                    else
                    {
                        await _memberRelationshipTypeService.Disable(RelationshipTypeId);
                    }
                }

                HttpContext.Session.SetString(SessionKey.NotificationMessage.Sucess, "Successfully updated relationship type");
            }
            catch (ArgumentException ex)
            {
                _logger.LogInformation(ex, ex.Message);
                HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)}");
            }
            catch (Exception ex)
            {
                if (ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                }
                else
                {
                    _logger.LogError(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, ErrorMessage.ErrorMessageDefault.ErrorDescription);
                }
            }

            return Redirect("~/RelationshipType/List");
        }
    }
}

BeamAndGo.Member.Admin.Web/Pages/RelationshipType/List.cshtml
@page
@model BeamAndGo.Member.Admin.Web.Pages.RelationshipType.RelationshipTypeListModel
@{
    ViewData["Title"] = "Relationship Type List";
}

<style>
    .filter tr {
        cursor: pointer;
    }
</style>

<body>
    <div class="uk-container uk-container-center">
        <div class="uk-grid-small" uk-grid>
            <div class="uk-width-1-6@m uk-visible@m">
                @{
                    await Html.RenderPartialAsync("_Menu");
                }
            </div>

            <div class="uk-width-expand@m">
                <div class="uk-card uk-card-default uk-card-body">
                    <h3 class="uk-card-title">@ViewData["Title"]</h3>

                    <div uk-filter="target: .filter" class="uk-width-1-1 filter-main">
                        <table class="uk-table">
                            <tbody>
                                <tr>
                                    <td class="uk-text-nowrap uk-align-right">
                                        <button class="bng-modal uk-button uk-button-primary" uk-toggle="target: #modal-relationshipType-create">Add Relationship Type</button>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                        <div class="uk-overflow-auto">
                            <table class="uk-table uk-table-hover uk-table-middle uk-table-divider">
                                <thead>
                                    <tr>
                                        <th class="uk-text-nowrap">Relationship Type Name</th>
                                        <th class="uk-text-nowrap">Gender</th>
                                    </tr>
                                </thead>
                                <tbody id="table-body" class="filter">
                                    @foreach (var m in Model.MemberRelationshipTypes)
                                    {
                                        <tr>
                                            <td class="uk-text-nowrap uk-table-expand">@m.Name</td>
                                            <td class="uk-text-nowrap uk-table-expand">@m.Gender</td>
                                            <td class="uk-text-nowrap uk-width-small">
                                                <button class="member-relationshipType-edit uk-button"
                                                        uk-toggle="target: #modal-relationshipType-edit"
                                                        SelectedRelationshipTypeSID="@m.Id"
                                                        SelectedRelationshipTypeName="@m.Name"
                                                        SelectedRelationshipTypeGender="@m.Gender"
                                                        SelectedAccessStatus="@m.RecordStatus">
                                                    <i class="fas fa-pencil-alt"></i>
                                                </button>
                                            </td>
                                            <td class="uk-text-nowrap uk-width-small">
                                                <button class="member-relationshipType-remove uk-button"
                                                        uk-toggle="target: #modal-relationshipType-remove"
                                                        SelectedRelationshipTypeSID="@m.Id"
                                                        SelectedRelationshipTypeName="@m.Name">
                                                    <i class="fas fa-trash"></i>
                                                </button>
                                            </td>
                                        </tr>
                                    }
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</body>

<!-- This is the modal -->
<div id="modal-relationshipType-create" uk-modal class="uk-flex-top modal-relationshipType-create">
    <div class="uk-modal-dialog uk-margin-auto-vertical">
        <div class="uk-modal-body">
            <h3>Create Relationship Type</h3>
            <div class="uk-card uk-card-default uk-card-small uk-card-body">
                <form method="post" asp-page-handler="CreateRelationshipType" asp-antiforgery="true">
                    <div class="uk-margin-small">
                        <label class="uk-form-label"> Relationship Type Name </label>
                        <input class="create-relationshipType uk-input" asp-for="@Model.RelationshipTypeName" type="text">
                    </div>

                    <div class="uk-margin-small uk-margin-medium-bottom">
                        <label class="uk-form-label">Gender</label>
                        <select class="uk-select" id="createRelationshipTypeGender" asp-for="@Model.RelationshipTypeGender">
                            <option selected value=@null disabled>Select Gender</option>
                            <option value="@(BeamAndGo.Member.GenderType.Female)">Female</option>
                            <option value="@(BeamAndGo.Member.GenderType.Male)">Male</option>
                            <option value="@null">Unspecified</option>
                        </select>
                    </div>

                    <div class="uk-margin-small">
                        <button class="uk-button uk-button-primary uk-width-1-1" type="submit">Add</button>
                    </div>
                    <div class="uk-margin-small">
                        <button class="uk-button uk-button-default uk-width-1-1 uk-modal-close" type="button">Cancel</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>
<!-- End of modal -->
<!-- This is the modal -->
<div id="modal-relationshipType-edit" uk-modal class="uk-flex-top modal-relationshipType-edit">
    <div class="uk-modal-dialog uk-margin-auto-vertical">
        <div class="uk-modal-body">
            <h3>Update Relationship Type</h3>
            <div class="uk-card uk-card-default uk-card-small uk-card-body">
                <form method="post" asp-page-handler="UpdateRelationshipType" asp-antiforgery="true">
                    <input class="member-relationship-current-status-input" asp-for="@Model.CurrentRelationshipTypeStatus" type="hidden" />
                    <input class="member-relationshipType-edit-input" asp-for="@Model.RelationshipTypeId" type="hidden">
                    <div class="uk-margin-small">
                        <label class="uk-form-label">Relationship Type Name </label>
                        <input class="edit-relationshipType uk-input" asp-for="@Model.RelationshipTypeName" type="text">
                    </div>

                    <div class="uk-margin-small">
                        <label class="uk-form-label">Gender</label>
                        <select class="uk-select" id="updateRelationshipTypeGender" asp-for="@Model.RelationshipTypeGender">
                            <option value="@(BeamAndGo.Member.GenderType.Female)">Female</option>
                            <option value="@(BeamAndGo.Member.GenderType.Male)">Male</option>
                            <option selected value="@null">Unspecified</option>
                        </select>
                    </div>

                    <div class="uk-margin-small uk-margin-medium-bottom">
                        <label class="uk-form-label">Record Status</label>
                        <div>
                            @foreach (var accessStatus in System.Enum.GetValues(typeof(BeamAndGo.Core.Data.RecordStatus)).OfType<BeamAndGo.Core.Data.RecordStatus>())
                            {
                                <label><input class="uk-radio" id="Record_@accessStatus" type="radio" asp-for="RelationshipTypeStatus" value="@accessStatus" /><span style="padding-right: 5px;"></span>@accessStatus<span style="padding-right: 10px;"></span></label>
                            }
                        </div>
                    </div>
                    <div class="uk-margin-small">
                        <button class="uk-button uk-button-primary uk-width-1-1" type="submit">Update</button>
                    </div>
                    <div class="uk-margin-small">
                        <button class="uk-button uk-button-default uk-width-1-1 uk-modal-close" type="button">Cancel</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>
<!-- End of modal -->
<!-- This is the modal -->
<div id="modal-relationshipType-remove" uk-modal class="uk-flex-top modal-relationshipType-remove">
    <div class="uk-modal-dialog uk-margin-auto-vertical">
        <div class="uk-modal-body uk-text-center">
            <p> Are you sure you want to delete <i><span class="remove-relationshipType">beamandgo</span></i>?</p>
            <form method="post" asp-page-handler="removeRelationshipType" asp-antiforgery="true">
                <input type="hidden" asp-for="@Model.RelationshipTypeId" id="remove-relationshipType-selected" class="member-relationshipType-remove-input" />
                <button class="uk-button uk-button-primary" type="submit">Ok</button>
                <button class="uk-button uk-button-default uk-modal-close" type="button">Cancel</button>
            </form>
        </div>
    </div>
</div>
<!-- End of modal -->
<script>
    $(document).ready(function () {
    });

    $('.member-relationshipType-edit').click(function () {
        $('.edit-relationshipType').val($(this).attr('SelectedRelationshipTypeName'));
        $('.member-relationshipType-edit-input').val($(this).attr('SelectedRelationshipTypeSID'));
        $('.member-relationship-current-status-input').val($(this).attr('SelectedAccessStatus'));
        $('#updateRelationshipTypeGender').val($(this).attr('SelectedRelationshipTypeGender')).change();

        $("#Record_" + $(this).attr('SelectedAccessStatus')).attr("checked", "checked");
    });

    $('.member-relationshipType-remove').click(function () {
        $('.remove-relationshipType').text($(this).attr('SelectedRelationshipTypeName'));
        $('.member-relationshipType-remove-input').val($(this).attr('SelectedRelationshipTypeSID'));
    });
</script>